南京网络赛E-AC Challenge【状压dp】

Dlsj is competing in a contest with n (0 < n \le 20)n(0<n≤20) problems. And he knows the answer of all of these problems.

However, he can submit ii-th problem if and only if he has submitted (and passed, of course) s_isi​ problems, the p_{i, 1}pi,1​-th, p_{i, 2}pi,2​-th, ......, p_{i, s_i}pi,si​​-th problem before.(0 < p_{i, j} \le n,0 < j \le s_i,0 < i \le n)(0<pi,j​≤n,0<j≤si​,0<i≤n) After the submit of a problem, he has to wait for one minute, or cooling down time to submit another problem. As soon as the cooling down phase ended, he will submit his solution (and get "Accepted" of course) for the next problem he selected to solve or he will say that the contest is too easy and leave the arena.

"I wonder if I can leave the contest arena when the problems are too easy for me."
"No problem."
—— CCF NOI Problem set

If he submits and passes the ii-th problem on tt-th minute(or the tt-th problem he solve is problem ii), he can get t \times a_i + b_it×ai​+bi​ points. (|a_i|, |b_i| \le 10^9)(∣ai​∣,∣bi​∣≤109).

Your task is to calculate the maximum number of points he can get in the contest.

Input

The first line of input contains an integer, nn, which is the number of problems.

Then follows nn lines, the ii-th line contains s_i + 3si​+3 integers, a_i,b_i,s_i,p_1,p_2,...,p_{s_i}ai​,bi​,si​,p1​,p2​,...,psi​​as described in the description above.

Output

Output one line with one integer, the maximum number of points he can get in the contest.

Hint

In the first sample.

On the first minute, Dlsj submitted the first problem, and get 1 \times 5 + 6 = 111×5+6=11 points.

On the second minute, Dlsj submitted the second problem, and get 2 \times 4 + 5 = 132×4+5=13 points.

On the third minute, Dlsj submitted the third problem, and get 3 \times 3 + 4 = 133×3+4=13 points.

On the forth minute, Dlsj submitted the forth problem, and get 4 \times 2 + 3 = 114×2+3=11 points.

On the fifth minute, Dlsj submitted the fifth problem, and get 5 \times 1 + 2 = 75×1+2=7 points.

So he can get 11+13+13+11+7=5511+13+13+11+7=55 points in total.

In the second sample, you should note that he doesn't have to solve all the problems.

样例输入1复制

5
5 6 0
4 5 1 1
3 4 1 2
2 3 1 3
1 2 1 4

样例输出1复制

55

样例输入2复制

1
-100 0 0

样例输出2复制

0

题目来源

ACM-ICPC 2018 南京赛区网络预赛

 

因为n小于20 所以可以往状压上去想

每个题做与不做就是一种状态

枚举每种状态i 再枚举这个状态下最后做的题目j

通过状态转移方程 dp[i] = max(dp[i], dp[i ^ (1 << (j - 1))] + t * a[j] + b[j]

其中t是i中1的个数,也就是第j题如果最后做对应的时间

对于每一种状态i 要判断他这种状态所表示的所有做的题目成立不成立 也就是他这种状态是否成立

也就是说他所有是1的题目 都要判断是否满足他的要求

要求也可以转换为状态来存

 

另外: maxn = 25 会MLE, maxn = 21就过了

过程中忘记对i这个状态是否成立进行判断了


#include<iostream>
#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<stack>
#include<queue>
#include<map>
#include<vector>
#include<set>
//#include<bits/stdc++.h>
#define inf 0x3f3f3f3f
using namespace std;
typedef long long LL;

const int maxn = 21;

struct pro{
    int a, b, s;
    int must;
}problems[maxn];
int dp[1 << maxn], n;

void init()
{
    for(int i = 0; i < maxn;i++){
        problems[i].must = 0;
    }
    memset(dp, 0, sizeof(dp));
}

int main()
{
    while(scanf("%d", &n) != EOF){
        init();
        for(int i = 1; i <= n; i++){
            scanf("%d%d%d", &problems[i].a, &problems[i].b, &problems[i].s);
            for(int j = 0; j < problems[i].s; j++){
                int p;
                scanf("%d", &p);
                problems[i].must |= (1 << (p - 1));
            }
        }

        int ans = 0;
        for(int i = 0; i < (1 << n); i++){
            bool flag = true;
            for(int j = 1; j <= n; j++){
                if((i & (1 << (j - 1))) == 0){
                    continue;
                }
                if((i & problems[j].must) != problems[j].must){
                    flag = false;
                    break;
                }
            }
            if(!flag) continue;
            for(int j = 1; j <= n; j++){
                if((i & (1 << (j - 1))) == 0){
                    continue;
                }
                int t = 0, tmp = i;
                while(tmp){
                    if(tmp & 1)
                        t++;
                    tmp >>= 1;
                }
                dp[i] = max(dp[i], dp[i ^ (1 << (j - 1))] + t * problems[j].a + problems[j].b);
                //ans = max(ans, dp[i]);
            }
        }


        printf("%d\n", dp[(1<<n) - 1]);
    }
	return 0;
}

 

转载于:https://www.cnblogs.com/wyboooo/p/9643372.html

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值